function Edit () {

    var editor = null;
    
    function hideEditor(selector) {
        if (!editor) return;
        selector.style.display = "";
        try { selector.parentElement.removeChild(editor); }
        catch (ex) { /*  NOP - may already have been removed in 'blur'. */ }
    }

    function showEditor(selector, value, onSelect) {                 
        currentValue  = selector.getAttribute("value");

        editor = document.createElement("input");
        editor.className = "ValueEditor";
        editor.value = value;

        editor.addEventListener("blur", function (evt) {
            selector.style.display = "";

            selector.setAttribute("value", editor.value.trim());
            onSelect({ originalTarget: selector });
            selector.parentElement.removeChild(editor);
        });
        // TODO: Handle enter, escape and tab properly.

        selector.parentElement.insertBefore(editor, selector.nextElementSibling);
        selector.style.display = "none";

        editor.focus();
    }
    
    return {
        show: showEditor,
        hide: hideEditor
    }
}