function InlineEdit () {
    
    function removeEditor(owner) {
        var editors = owner.querySelectorAll(".InlineEditor");
        editors.forEach((editor, i) => {
            delete owner.dataset["extra" + i];
            owner.removeChild(editor); 
        });
    }

    function addEditor(owner, extra, i) {                 
        var value = owner.dataset["extra" + i];

        var editor = document.createElement("input");
        editor.className = "InlineEditor";
        editor.value = value || "";
        editor.placeholder = extra;

        editor.addEventListener("blur", function (evt) {
            owner.dataset["extra" + i] = editor.value.trim();
        });
        editor.addEventListener("keydown", function (evt) {
            switch(evt.key) {
                case "Escape":
                    editor.value = owner.dataset["extra"+1];
                    // Fall through
                case "Enter":
                case "Backspace":
                case "Delete":
                    // We handled it - or at least we don't want browser to handle it.
                    evt.cancelBubble = true;
                    evt.preventDefault = true;
                    evt.stopImmediatePropagation();
                    evt.stopPropagation();
                    break;
                default:
                    break;
            }  
        });

        // TODO: Handle enter, escape and tab properly.

        owner.appendChild(editor);
        editor.focus();
    }
    
    return {
        add:    addEditor,
        remove: removeEditor
    }
}