ModalDialog = function (headerText, body, onConfirmHandler, styles) {
    var shield = document.createElement("div");
    shield.style.position   = "absolute";
    shield.style.background = "rgba(0,0,0,0.5)";
    shield.style.top        = "0px";
    shield.style.left       = "0px";
    shield.style.width      = "100%";
    shield.style.height     = "100%";
    shield.style.zIndex     = 999;
    
    document.body.appendChild(shield);
    
    var dialog = document.createElement("div");
    dialog.className = "ModalDialog";
    dialog.style.position = "absolute";
    dialog.style.zIndex   = 1000;
    
    if (styles) {
        for (var style in styles) {
            dialog.style[style] = styles[style];
        }
    }

    document.body.appendChild(dialog);
    
    var closeButton = document.createElement("div");
    closeButton.className = "DialogClose";
    closeButton.innerHTML = "&#215;";
    closeButton.addEventListener("click", function (evt) {
        document.body.removeChild(dialog); 
        document.body.removeChild(shield);
    });
    dialog.appendChild(closeButton);
    
    var header = document.createElement("div");
    header.className = "DialogHeader";
    header.innerHTML = headerText;

    dialog.appendChild(header);
    dialog.appendChild(body);
    
    var footer = document.createElement("div");
    footer.className = "DialogFooter";
    var confirmButton = document.createElement("input");
    confirmButton.type  = "button";
    confirmButton.value = "Confirm";
    confirmButton.addEventListener("click", function (evt) {
        var accept = onConfirmHandler(body);
        if (!accept) return;
        
        document.body.removeChild(dialog); 
        document.body.removeChild(shield);
    });
    
    footer.appendChild(confirmButton);
    dialog.appendChild(footer);
    
    dialog.style.left = "calc(50% - " + Math.round(dialog.offsetWidth / 2)+ "px)";
    dialog.style.top  = "150px";
}
