/*   var connections = [
        { val: 'S4rk9VFtSYymoeK0MYxE9' + '@' + 'https://qa-walmart.dynatrace-managed.com/e/c38f6cae-e032-4aee-9c62-60ffeb886c88/api/v1/',
          label: "PROD" }
    ]; */
/*    var connections = [
        { val: 'S4rk9VFtSYymoeK0MYxE9' + '@' + 'https://qa-walmart.dynatrace-managed.com/e/c38f6cae-e032-4aee-9c62-60ffeb886c88/api/v1/',
          label: "PROD" },
        { val: 'edit', label: "-Edit-"}
    ]; */    

function showConnectionDialog() {

    var onConfirm = function (container) {
        // Extract values from table and place in cookie.
        // Also re-create the dropdown.
        var table = container.firstElementChild;
        var connections = [];

        for (var i = 0; i < table.children.length; i++) {
            var row = table.children.item(i);
            if (row.nodeName.toLocaleLowerCase() !== "tr") continue;

            var inputs = row.getElementsByTagName("input");
            if (!inputs || inputs.length === 0) continue;

            if (inputs[0].value.trim() === "") {
                alert("Please provide a label for connection " + (i+1));
                return false;
            }

            connections.push({
                label: inputs[0].value.trim(),
                val:   inputs[2].value.trim() + "@" + 
                       inputs[1].value.trim()
            });
        }
        if (connections.length === 0) {
            alert("You must specify at least one connection");
            return false;
        }

        var clusterSelector = document.getElementById("clusterSelector");
        populateSelector(
            clusterSelector, 
            connections.concat({ val: 'edit', label: "-Edit-"}), 
            0);  
        setCookie("connections", JSON.stringify(connections), 90); // Expire after 90 days.
        return true;
    }

    var createRow = function (evt, connection) {
        connection = connection || { label: "", val: "@" };

        var row = document.createElement("tr");
        var labelCell = document.createElement("td");
        labelCell.innerHTML = '<input type="text" style="width:99%" value="' + connection.label + '">';

        var urlCell   = document.createElement("td");
        urlCell.innerHTML = '<input type="text" style="width:99%" value="' + connection.val.split("@")[1] + '">';

        var keyCell   = document.createElement("td");
        keyCell.innerHTML = '<input type="text" style="width:99%" value="' + connection.val.split("@")[0] + '">';

        var delCell   = document.createElement("td");
        delCell.className = "RemoveButton";
        delCell.innerHTML = '&#215;';
        delCell.addEventListener("click", removeRow);

        row.appendChild(labelCell);
        row.appendChild(urlCell);
        row.appendChild(keyCell);
        row.appendChild(delCell);

        if (evt) 
            evt.target.parentElement.parentElement.insertBefore(row, evt.target.parentElement);
        else
            return row;
    }

    var removeRow = function (evt) {
        evt.target.parentElement.parentElement.removeChild(evt.target.parentElement);
    }

    var connections = JSON.parse(getCookie("connections")) || [];

    var table = document.createElement("table");
    table.innerHTML = '<tr><th style="min-width:75px">Label</th><th style="width:70%">URL to Dynatrace Cluster</th><th style="min-width:150px">API Token</th><th style="min-width:25px"</tr>';

    connections.forEach(function (connection) {
        table.appendChild(createRow(null, connection));
    });

    var row  = document.createElement("tr");
    var cell = document.createElement("td");
    cell.className = "AddButton";
    cell.addEventListener("click", createRow);
    cell.innerHTML = "+";
    row.appendChild(cell);

    table.appendChild(row);
    
    var container = document.createElement("div");
    container.appendChild(table);
    
    var helpText = document.createElement("p");
    helpText.style.padding = "0px 8px";
    helpText.style.fontSize = "85%";
    helpText.innerHTML = '<b>NOTE:</b> The URL must be in the following form: "<span style="font-family:monospace">https://{your-domain}.dynatrace-managed.com/e/{your-environment-id}</span>". When in Dynatrace, refer to the browser address bar for the domain and environment ID values. Create an API token in "<b>Settings > Integrations > Dynatrace API</b>". <br/>Be sure to only select: "<i>Access problem and event feed, metrics, topology and RUM JavaScript tag management</i>".';
    
    container.appendChild(helpText);

    var dialog = new ModalDialog("Cluster Connections", container, onConfirm, { width: "600px" });
}       
