function escapeHTMLChars(textString) {
    if (!textString)
        return "";

    var encodeChars  = ["quot", "amp", "apos", "lt", "gt"];     
    var charEntities = {
        quot: '"',
        amp:  "&",
        apos: "'",
        lt:   "<",
        gt:   ">"
    };

    // We don't want to replace the ampersand in things like '&apos;', so for that case we
    // use a RegExp that ensures that no '&' that is part of a character entity is matched.
    // Note that those things can be between 2 and 8 characters in length.
    var singleAmp = new RegExp("&(?!([a-zA-Z]{2,8};))", "g");  

    // Global find-and-replace of given character with its character entity equivalent.
    for (var i=0; i < encodeChars.length; i++) {
        textString = encodeChars[i] == "amp"
                   ? textString.replace(singleAmp, "&amp;")
                   : textString.split(charEntities[encodeChars[i]]).join("&"+encodeChars[i]+";"); 
    }
    return textString;
}
