
const tagTemplate =
    '<div class="TagArea">' +
    '<%if (this.tags && this.tags.length) {%>' +
        '<%for(var index in this.tags) {%>' +
            '<span class="Tag"><span class="Key"><%this.tags[index].context%>:<%this.tags[index].key%></span>' +
            '<%if (this.tags[index].value != "(no value)" && this.tags[index].value != "_empty") {%>' +
               '<span class="Key">=</span><span class="Value"> <%this.tags[index].value%></span>' +
            '<%}%>' +
            '</span>' +
        '<%}%>' +
    '<%} else {%>' +
        '<span class="NoTag">(no tags)</span>' +
    '<%}%>' +
    '</div>';

const tooltipTemplates = {
    APPLICATION:
    '<h1><%this.displayName%></h1>' +
    '<h2><a href="<%this.entityURL%>" target="_blank" style="float:right"><%this.entityId%></a><%this.applicationType%> <%this.mobileOsFamily%> APPLICATION</h2>' +
    '<table>' +
    '<tr><th>First seen:</th><td><%this.firstSeenTime%></td></tr>' +
    '<tr><th>Last seen:</th><td><%this.lastSeenTime%></td></tr>' +
    '</table>' + tagTemplate,

    SERVICE:
    '<h1><%this.displayName%></h1>' +
    '<h2><a href="<%this.entityURL%>" target="_blank" style="float:right"><%this.entityId%></a><%this.serviceType%></h2>' +
    '<table>' +
    '<tr><th>First seen:</th><td><%this.firstSeenTime%></td></tr>' +
    '<tr><th>Last seen:</th><td><%this.lastSeenTime%></td></tr>' +
    '<%if (this.agentTechnologyType) {%>' +
       '<tr><th>Agent type:</th><td><%this.agentTechnologyType%></td></tr>' +
    '<%}%>' +
    '<tr><th>Technologies:</th><td>' +
    '<%if (this.softwareTechnologies) {%>' +
        '<%for(var index in this.softwareTechnologies) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.softwareTechnologies[index].type%> <%this.softwareTechnologies[index].edition%> <%this.softwareTechnologies[index].version%>' +
        '<%}%>' +
    '<%} else {%>' +
        '-' +
    '<%}%>' +
    '</td></tr>' +
    '<%if (this.databaseName) {%>' +
       '<tr><th>Database:</th><td><%this.databaseName%> (<%this.databaseVendor%>)</td></tr>' +
    '<%}%>' +
    '<%if (this.databaseHostNames) {%>' +
        '<tr><th>Database hosts:</th><td>' +
        '<%for(var index in this.databaseHostNames) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.databaseHostNames[index]%>' +
        '<%}%>' +
        '</td></tr>' +
    '<%}%>' +
    '<%if (this.ipAddresses) {%>' +
        '<tr><th>Database IPs:</th><td>' +
        '<%for(var index in this.ipAddresses) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.ipAddresses[index]%>' +
        '<%}%>' +
        ' (port <%this.port%>)</td></tr>' +
    '<%}%>' +

    '</table>' + tagTemplate,

    PROCESS_GROUP:
    '<h1><%this.displayName%></h1>' +
    '<h2><a href="<%this.entityURL%>" target="_blank" style="float:right"><%this.entityId%></a>Process Group</h2>' +
    '<table>' +
    '<tr><th>First seen:</th><td><%this.firstSeenTime%></td></tr>' +
    '<tr><th>Last seen:</th><td><%this.lastSeenTime%></td></tr>' +
    '<tr><th>Technologies:</th><td>' +
    '<%if (this.softwareTechnologies) {%>' +
        '<%for(var index in this.softwareTechnologies) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.softwareTechnologies[index].type%> <%this.softwareTechnologies[index].edition%> <%this.softwareTechnologies[index].version%>' +
        '<%}%>' +
    '<%} else {%>' +
        '-' +
    '<%}%>' +
    '</td></tr>' +
    '<%if (this.metadata) {%>' +
        '<%for(var field in this.metadata) {%>' +
        '<tr><th><%field%>:</th><td>' +
            '<%for(var index in this.metadata[field]) {%>' +
                '<%if (index != 0) {%>, <%}%>' +
                '<%this.metadata[field][index]%>' +
            '<%}%>' +
        '</td></tr>' +
        '<%}%>' +
    '<%}%>' +
    '<tr><th>Listen ports:</th><td>' +
    '<%if (this.listenPorts) {%>' +
        '<%for(var index in this.listenPorts) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.listenPorts[index]%>' +
        '<%}%>' +
    '<%} else {%>' +
        '-' +
    '<%}%>' +
    '</td></tr>' +
    '</table>' + tagTemplate,

    PROCESS_GROUP_INSTANCE:
    '<h1><%this.displayName%></h1>' +
    '<h2><a href="<%this.entityURL%>" target="_blank" style="float:right"><%this.entityId%></a>Process</h2>' +
    '<table>' +
    '<tr><th>First seen:</th><td><%this.firstSeenTime%></td></tr>' +
    '<tr><th>Last seen:</th><td><%this.lastSeenTime%></td></tr>' +
    '<tr><th>Technologies:</th><td>' +
    '<%if (this.softwareTechnologies) {%>' +
        '<%for(var index in this.softwareTechnologies) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.softwareTechnologies[index].type%> <%this.softwareTechnologies[index].edition%> <%this.softwareTechnologies[index].version%>' +
        '<%}%>' +
    '<%} else {%>' +
        '-' +
    '<%}%>' +
    '</td></tr>' +
    '<%if (this.metadata) {%>' +
        '<%for(var field in this.metadata) {%>' +
        '<tr><th><%field%>:</th><td>' +
            '<%for(var index in this.metadata[field]) {%>' +
                '<%if (index != 0) {%>, <%}%>' +
                '<%this.metadata[field][index]%>' +
            '<%}%>' +
        '</td></tr>' +
        '<%}%>' +
    '<%}%>' +
    '<tr><th>Listen ports:</th><td>' +
    '<%if (this.listenPorts) {%>' +
        '<%for(var index in this.listenPorts) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.listenPorts[index]%>' +
        '<%}%>' +
    '<%} else {%>' +
        '-' +
    '<%}%>' +
    '</td></tr>' +
    '</table>' + tagTemplate,

    HOST:
    '<h1><%this.displayName%></h1>' +
    '<h2><a href="<%this.entityURL%>" target="_blank" style="float:right"><%this.entityId%></a><%this.osType%></h2>' +
    '<table>' +
    '<tr><th>First seen:</th><td><%this.firstSeenTime%></td></tr>' +
    '<tr><th>Last seen:</th><td><%this.lastSeenTime%></td></tr>' +
    '<tr><th>Operating System:</th><td><%this.osVersion%></td></tr>' +
    '<%if (this.publicHostName) {%>' +
    '<tr><th>Public host name:</th><td><%this.publicHostName%> (<%this.publicIp%>)</td></tr>' +
    '<%}%>' +
    '<%if (this.localHostName) {%>' +
    '<tr><th>Local host name:</th><td><%this.localHostName%> (<%this.localIp%>)</td></tr>' +
    '<%}%>' +
    '<%if (!this.publicHostName && !this.localHostName) {%>' +
    '<tr><th>IP addresses:</th><td>' +
        '<%for(var index in this.ipAddresses) {%>' +
            '<%if (index != 0) {%>, <%}%>' +
            '<%this.ipAddresses[index]%>' +
        '<%}%>' +
    '</td></tr>' +
    '<%}%>' +
    '<%if (this.agentVersion) {%>' +
    '<tr><th>Monitoring agent:</th><td><%this.agentVersion.major%>.<%this.agentVersion.minor%>.<%this.agentVersion.revision%>.<%this.agentVersion.timestamp%> (<%this.monitoringMode%>)</td></tr>' +
    '<%}%>' +
    '</table>' + tagTemplate

};
