# Class: CancellableEventEmitter


## CancellableEventEmitter

**A cancellable event emitter at which the progress of a request
can be monitored and at which the request can be canceled. See the NodeJS
<a href="/doc/index.html#/apis/https://nodejs.org/api/events.html?id=events_class_eventemitter">EventEmitter</a>
documentation for more information.**





### Constructor


#### <span class="type-signature"></span>new CancellableEventEmitter<span class="signature">(request)</span><span class="type-signature"></span>


Creates an instance.






##### Parameters:

|Name|Type|Description|
|----|----|-----------|
|`request`|*object*|An object that should expose an 'abort()' method
that accepts a <a href="/doc/index.html#/apis/global?id=RequestError">RequestError</a>.|























*Source:*
<a href="/doc/index.html#/apis/DynatraceAPI.js">DynatraceAPI.js</a>, <a href="/doc/index.html#/apis/DynatraceAPI.js?id=L56">line 56</a>























---------------

### Extends

- EventEmitter














### Methods






#### <span class="type-signature"></span>cancel<span class="signature">(reason)</span><span class="type-signature"></span>


Cancel the request. It will either (1) cause the <a href="/doc/index.html#/apis/global?id=RequestCallback">RequestCallback</a> provided to
the <a href="/doc/index.html#/apis/DynatraceAPI?id=request">DynatraceAPI#request</a> method to be called, or (2) the  <a href="/doc/index.html#/apis/CancellablePromise">CancellablePromise</a>
returned by <a href="/doc/index.html#/apis/DynatraceAPI?id=request">DynatraceAPI#request</a> to reject. In both cases a <a href="/doc/index.html#/apis/global?id=RequestError">RequestError</a>
will be passed as the first argument, with code 500 and this reason as its message.






##### Parameters:

|Name|Type|Description|
|----|----|-----------|
|`reason`|*string*|The reason for the cancellation.|























*Source:*
<a href="/doc/index.html#/apis/DynatraceAPI.js">DynatraceAPI.js</a>, <a href="/doc/index.html#/apis/DynatraceAPI.js?id=L75">line 75</a>