# Class: CancellablePromise


## CancellablePromise

**A cancellable Promise. This is technically not a real 'Promise', but rather an emulation that
also exposes a 'cancel(reason)' method.
See the <a href="/doc/index.html#/apis/https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promise</a>
documentation for more information. Note: this class is documented for informational purposes
only. You cannot create your own instance of this class.**





### Constructor


#### <span class="type-signature"></span>new CancellablePromise<span class="signature">()</span><span class="type-signature"></span>





























*Source:*
<a href="/doc/index.html#/apis/DynatraceAPI.js">DynatraceAPI.js</a>, <a href="/doc/index.html#/apis/DynatraceAPI.js?id=L95">line 95</a>























---------------

### Extends

- Promise














### Methods






#### <span class="type-signature"></span>cancel<span class="signature">(reason)</span><span class="type-signature"></span>


Cancel the promise. It will cause the promise to reject with a <a href="/doc/index.html#/apis/global?id=RequestError">RequestError</a>
with code 500 and this reason as its message. This method should only be
called after 'then()' and 'catch()' have been called.






##### Parameters:

|Name|Type|Description|
|----|----|-----------|
|`reason`|*string*|The reason for the cancellation.|























*Source:*
<a href="/doc/index.html#/apis/DynatraceAPI.js">DynatraceAPI.js</a>, <a href="/doc/index.html#/apis/DynatraceAPI.js?id=L102">line 102</a>