Components
=====

**StreamerService**
The StreamerService exposes the configuration UI. It is also responsible for kicking off a new cycle every minute, collecting the jobs for execution for each cycle, assigning them to Workers, and tracking their completions. It manages (i.e. starts, kills) the collection of Workers it needs. 

**Worker**
The Worker is responsible for performing any jobs assigned to it every cycle. Its implementation is documented visually later in this document. It can output its data using any component that implements the DestinationAPI.

**LibraryService**
The LibraryService synchronizes with Dynatrace and exposes the LibraryService APIs at its own HTTP port. It can be embedded in the StreamerService, be started by the StreamerService as a separate process, or be started ‘manually and run as a stand-alone process. Note that a swagger file is available that documents the library’s interface (at /doc).

**ThrottleService**
The ThrottleService (not shown in diagram below) load-balances and rate-limits access to the configured Dynatrace hosts. Its main component is the DynatraceAPI class, which is also used by the LibraryService and the Worker.

**ConfigService**
The ConfigService (not shown in diagram below) is a stand-alone utility. It provides a way to log on to a Managed Dynatrace cluster and perform arbitrary REST calls that the Dynatrace UI uses as well. It can be used for automation and data extraction scenarios for which only the Dynatrace UI provides the relevant ‘access points’. 

![image.png](/.attachments/image-2ca1fa94-4fa8-41fe-af7d-bd3482d2a7e4.png)