Deployment
=====

The StreamingAPI can be downloaded from https://gitlab.com/BartOostlander/dynatrace-streamingapi and requires Node.JS 10.x or higher, plus recent versions of mariadb or mysql, kafka-node, express, cors, axios, winston, node-cleanup, cookie-parser, async and socket.io (installable with npm install – see /server/package.json).

The solution is intended to be deployed in a separate, dedicated VM close to the Dynatrace Cluster. Endpoints for the destinations should be provisioned close (i.e. minimal hops, same network, sufficient bandwidth) as well, as the speed with which the solution pushes messages to the targeted infrastructure (e.g. a message bus) may affect the overall performance of the solution. The database should be provisioned as close as possible to the VM as well.

The StreamerService is started from the ‘/server’ folder with the following command: node StreamerService.js. Example launch configurations for Visual Studio Code can be found in /.vscode/launch.json. Alternatively, PM2 may be used. An example ecosystem.config.js file is located in the root of the codebase. A failover instance of the StreamerService can be started as follows: node StreamerService.js failover.

Note that while the LibraryService may be automatically started by the streamer, it can also be started independently (using the command node LibraryService.js, executed from the ‘server’ folder). This allows for scenarios where only the advanced query interface of the LibraryService is required, but also allows the StreamerService to run independently of the library. In the latter case it is important to configure the config.json file such that the StreamerService (streamer) knows not to start the library autonomously. Finally, it is possible to run the LibraryService as an embedded engine in the StreamerService.
