Solution
=====

The solution consists of the following components:
- A web application to expose a UI in which the user can select entities, sessions, metrics and timeframes. The UI also reports on key deployment, performance and behavioral characteristics to help users make informed decisions with respect to the stress their selections impose on the Dynatrace API.
- A StreamerService that determines which jobs are due for execution at each minute, assigns the work, and controls the automated deployment of worker processes to maximize throughput.
- A variable collection of Worker processes that round-robin across available API endpoints to process their part of the overall workload.
- A LibraryService that analyzes and indexes all Dynatrace entities for fast filtering and retrieval. It exposes a public query interface that is (also) used by the StreamerService to select the appropriate entities for each job that is due.
- A ThrottleService that can be used as a stand-alone gateway to protect access to the Dynatrace API.
- A ConfigService that can be used to access arbitrary Dynatrace REST APIs (Managed only).
