Using the ConfigService
=====

The ConfigService is a stand-alone program that exposes REST APIs to access REST calls that are exposed through the Dynatrace UI. Such call cannot normally be made due to security constraints. This utility addresses that. It provides the following facilities:
- Establish a session under which all subsequent requests can be made to Dynatrace, at **/login/{tenant}**.
- Set/get the monitoring mode for one or more hosts at **/config/{tenant}/HOST/monitoringMode**. 
- Set/get any monitoring setting for one or more services, process groups, process group instances and hosts at **/config/{tenant}/{entityType}/monitoringSetting**. This endpoint resolves to the following (respective) URLs in the Dynatrace UI:
  - SERVICE: "/rest/configuration/deployment/entities/SERVICE"
  - PROCESS_GROUP: "/rest/configuration/deployment/entities/PROCESS_GROUP"
  - PROCESS: "/rest/configuration/deployment/entities/PROCESS"
  - HOST: "/rest/configuration/deployment/entities/HOST"
- Execute any custom request (or series of requests) at /custom/{tenant}/{requestName}. These requests are defined in config.json (or in a file that the HTTPScripts property in config.json refers to).

Note that full documentation for these endpoints is available in the API Explorer, accessible from the StreamingAPI Editor or directly at http://(host:port)/doc. 

**Session management**
The most critical functionality that the ConfigService provides is the ability to establish a user session against the Dynatrace UI. In the context of that session any Dynatrace REST request can be executed. To that end, the ConfigService implements the client side of Dynatrace’s login protocol – but it currently only does that for Managed clusters. SaaS clusters use SAML, which the ConfigService does not yet support.

To establish a session, users call the **/login/{tenant}** URL first. After that, any other endpoint can be called. If the ‘login’ URL is not called first, the requests will automatically be performed in the context of a session established using a service account, the credentials of which can be configured in the "account" property of the appropriate tenant in config.json.

**Custom request scripting**
The custom requests can be configured directly in config.json, or in a separate json file. A request can be a single URL or a series of URLs to be executed in sequence. In that scenario, subsequent URLs can use responses from previous requests to configure the request parameters and (optionally) form data.

For a complete description of the options and the syntax, see the "httpscripts.json" section in the Configuration chapter.
