Job Editor
=====

To avoid overloading Dynatrace, the job editor is designed to encourage a deliberate configuration of specific collections of entities and metrics. When a job is first created the user must select a source, destination and type (user session, host, service, etc.). For entity-based jobs the resulting set of entities available for inclusion in the job can be further constrained by Management Zone. Field and tag filters can be used to isolate the desired subset. From there, users can select all or some of the displayed entities and add them to the job, or create groups of criteria to define the contents of the job. For user session-based jobs the editor effectively enables the user to create (and test) a USQL query interactively.

Any number of metrics can be added. By default, the average value for a metric will be collected. The user can select any of the available aggregators on each metric from a menu. Also, above the selected list of metrics is a control that allows users to configure the metric granularity for the job.

Below are the three variants of the UI for 
1. Entity-based jobs with explicitly selected entities
2. Entity-based jobs with a criteria-based entity selection
3. User-session/action-based jobs defined in terms of a USQL query. 

Note that a "Test" panel is always available (expandable via a handle at the bottom of the page) at which the current job can be tested and validated. This panel can also be used for ad-hoc queries (as temporary jobs). The rows are selectable and can be copied directly into Excel or a text file for further analysis and reporting.

![image.png](/.attachments/image-485ec94a-d702-4763-88c7-fa5071bb5914.png)

![image.png](/.attachments/image-690210cd-8293-4d18-9661-6f29cc4815b1.png)

![image.png](/.attachments/image-2bb58ef4-deea-40ac-8546-e3c00978953f.png)
