import os
import sys
if (os.name == 'nt'):
    sys.path.insert(1, os.getcwd() + "\\pylib")
else:
    sys.path.insert(1, os.getcwd() + "/pylib")

from ruxit.api.base_plugin import RemoteBasePlugin
from ruxit.api.exceptions import ConfigException

import logging
import requests

logger = logging.getLogger(__name__)

class Initializer(RemoteBasePlugin): 

    def query(self, **kwargs):
        stats = requests.get('https://127.0.0.1:8080/api/health', verify = False).json()

        # Use plugin.json to get metric names and dimension names.
        # Iterate over stats (metrics) array. In each:
        # metricId, dimension values (in same order as in plugin.json), value.

        # Create group - provide group id used to calculate unique entity id in dynatrace
        #   and display name for UI presentation
        group = self.topology_builder.create_group(identifier="esa-etl-service-v2",
                                                   group_name="Dynatrace ESA ETL Service")


        # Create device - provide device id used to calculate unique entity id in dynatrace
        #   and display name for UI presentation
        device = group.create_device(identifier="libraryService-kkr05643",
                                    display_name="ESA Solution Server")

        if(self.config['sslKey']):
            stats = requests.get('https://127.0.0.1:' + self.config['port'] + '/api/health', ).json()
        else:
            stats = requests.get('http://127.0.0.1:' + self.config['port'] + '/api/health').json()

        device.absolute(key='runningPlugins', value=stats['runningPlugins'])
        device.absolute(key='crashedPlugins', value=stats['crashedPlugins'])
        device.absolute(key='awaitingConfigPlugins', value=stats['awaitingConfigPlugins'])
        device.absolute(key='extensions', value=stats['extensions'])
