/* LevelDB Adaptor 
    DOES NOT WORK
*/
'use strict';
const level = require('level');
// Ask Andrew for help with 'level' ;-)
const sublevel = null; // require('level-sublevel')


 /**
  * A LevelDB-specific implementation of the DatabaseAPI.
  * @extends DatabaseAPI
  * @private
  */
class LevelDBAdaptor {
    constructor(config, logger) {
        logger.info("    Initializing leveldb adaptor");
        this.logger = logger;
        const db = sublevel(level('my-level-db', {valueEncoding: 'json'}));
        
        this.entitydb = db.sublevel('entities');
        this.tenantdb = db.sublevel('tenants');
        this.entityTypedb = db.sublevel('entityTypes');
        this.lastSeendb = db.sublevel('lastseen');
        this.busy = 0;
        logger.info("    leveldb adaptor initialized");
    }

    createConnection(taskName, resolve, reject, cleanup) {
        const self = this;

        return {
            name:    taskName,
            resolve: resolve,
            reject:  reject,
            cleanup: cleanup,
            state:   "Queued",
            initialize: function (conn) {
                this.state  = "Connected";
                self.busy = 1;
                this.conn = conn;
            },
            begin: function (){
                // do nothing for now
            },
            queryo: function (statement, values) {
                console.log(statement);
                console.log(values);
                self.entitydb.get("HEALTHCHECK", function (error, val){
            
                    console.log(error);
                    console.log(val);
                    return (error, val);
                  })


                //return this.entitydb.get(values[0])

                return "testing";
                
            },
            query: function (operation, key, value) {
                return new Promise((resolve, reject) => {

                    if (operation === "GET"){
                        self.entitydb.get(key, ((err, results) => {
                            if (err)
                                reject(err);
                            else {
                                resolve(results);
                            }
                        }));
                    }
                    else if (operation == "PUT"){
                        /// NEED TO ADD KEY FUNCTIONS AS WELL
                        self.entitydb.put(key, value, ((err, results) => {
                            if (err)
                                reject(err);
                            else {
                                resolve(results);
                            }
                        }));
                    }
                    else {
                        reject("INVALID OPERATION")
                    }
                });
            },
            stream: function (statement, values) {
                console.log(statement);
            },
            commit: function (onDone, onError) {
                // no commit concept. always "done" if called, for now
                onDone && onDone();
            },
            rollback: function (onDone, onError) {
                // no rollback concept. always "done" if called, for now
                onDone && onDone();
            },
            release: function (onReleased, noCleanup) {
                const self = this;
                //console.log("gothere");
                const finish = function () {
                    if (!noCleanup) self.cleanup(self);
                    if (onReleased) setTimeout(onReleased, 1);
                    onReleased = null;
                    self.conn = null;
                    self.busy = 0;
                };

                if (this.conn) {
                    //this.conn.release();
                    finish();
                    //console.log(this.conn);
                }
                else {
                    finish();   // Yes, always.
                }
            }
        };
    }

    acquire(connection, onAcquired) {
        connection.state = "Connecting";

        connection.initialize(connection);
        connection.resolve(connection);
        if (onAcquired) onAcquired();

    }

    get activeConnections() {
        console.log("returning active " + this.busy);
        return this.busy;
    }

    get totalConnections() {
        return 1;
    }

    close(resolve) {
        this.entitydb.close((err) => {
            this.tenantdb.close((err2) => {
                this.entityTypedb.close((err3) => {
                    this.lastSeendb.close((err4) => {
                        resolve && resolve();
                    })
                })
            })
        });
    }
}

module.exports = LevelDBAdaptor;