const puppeteer = require('puppeteer');

const sleep = (sleepTimeMs) => {
    return new Promise(r => setTimeout(r, sleepTimeMs));
};

async function getAzureSSOCookies(config) {
    const browser = await puppeteer.launch({ headless: false });
    const page = await browser.newPage();
    await page.goto(config.dynatraceUIScreen);

    // Wait for the "Next" button to be loaded
    await page.waitFor('input.text-box[type=email][name=loginmft]');
    await sleep(50);
    await page.type("input.text-box[type=email][name=loginmft]", config.userEmail);

    // Submit button
    await sleep(50);
    await page.click('input[type=submit]');

    await page.waitFor('input.text-box[type=password][name=passwd]');
    await sleep(50);
    await page.type("input.text-box[type=password][name=passwd]", config.userPassword);

    await sleep(250);
    await page.click('input[type=submit]');

    // If this button is present, click yes
    await sleep(2500);

    // check for "Remember my decision"
    const hasSubmitButton = await page.evaluate((document) => {
        return document.querySelectorAll('input[type=submit]').length > 0;
    });
    if (hasSubmitButton) {
        await page.click('input[type=submit]');
        await sleep(2500);
    }

    // Should be in CMC or Env UI
    await page.waitFor('input.text-box[type=password][name=passwd]');

    // Return cookies
    return await page.cookies();
}


module.exports = getAzureSSOCookies;
